use std::fmt;
use std::future::Future;
use futures::FutureExt;

use slog::Logger;

use super::connection_capnp::bootstrap::Client;
use super::Authentication;

#[derive(Clone)]
pub struct API {
    inner: Client,
    log: Logger,
}

impl API {
    pub fn new(log: Logger, inner: Client) -> Self {
        Self { log, inner}
    }

    pub fn authentication(&mut self) -> impl Future<Output=Authentication> {
        let req = self.inner.auth_request().send().promise;
        // TODO: When's that an Err?
        req.map(|res| {
            // TODO: When's that an Err?
            let tmp = res.unwrap();
            let moretmp = tmp.get().unwrap();
            Authentication::new(moretmp.get_auth().unwrap())
        })
    }

    ///// Authenticate to the server. Returns true on success, false on error
    //async fn authenticate(&mut self) -> Result<bool, io::Error> {
    //    let mut sasl = SASL::new().unwrap();
    //    let plain = std::ffi::CString::new("PLAIN").unwrap();
    //    let mut sess = sasl.client_start(&plain).unwrap();
    //    sess.set_property(rsasl::Property::GSASL_AUTHID, b"testuser");
    //    sess.set_property(rsasl::Property::GSASL_PASSWORD, b"testpass");

    //    if let rsasl::Step::Done(data) = sess.step(&[]).unwrap() {
    //        self.send_authentication_request("PLAIN", Some(&data)).await;
    //    } else {
    //        println!("Sasl said moar data");
    //    }

    //    Ok(self.receive_challenge().await?)
    //}

    //fn send_authentication_request(&mut self, mech: &str, init: Option<&[u8]>) -> impl Future<Output=()> {
    //    let mut outer = capnp::message::Builder::new_default();
    //    let mut builder = outer.init_root::<connection_capnp::message::Builder>()
    //        .init_auth()
    //        .init_request();
    //    builder.set_mechanism(mech);

    //    if let Some(data) = init {
    //        builder.init_initial_response().set_initial(data);
    //    }

    //    let stream = self.stream.clone();
    //    capnp_futures::serialize::write_message(stream, outer).map(|r| r.unwrap())
    //}

    //async fn receive_challenge(&mut self) -> Result<bool, io::Error> {
    //    let message = capnp_futures::serialize::read_message(&mut self.stream, capnp::message::ReaderOptions::default()).await.unwrap().unwrap();
    //    let m = message.get_root::<connection_capnp::message::Reader>().unwrap();

    //    if let Ok(connection_capnp::message::Which::Auth(Ok(r))) = m.which() {
    //        if let Ok(auth_capnp::auth_message::Outcome(Ok(r))) = r.which() {
    //            if let Ok(auth_capnp::outcome::Result::Successful) = r.get_result() {
    //                return Ok(true);
    //            }
    //        }
    //    }

    //    return Ok(false);
    //}
}
